Index: /cpp/gdk/Makefile
===================================================================
--- /cpp/gdk/Makefile	(revision 103)
+++ /cpp/gdk/Makefile	(revision 104)
@@ -14,5 +14,5 @@
 #   defassign-f0_neuroconn.h f0def.xml neurocls-library.h neurocls-factory.h model.def
 
-TARGETS=convtest gdktest genotest neurotest loadertest f0def.xml model.def
+TARGETS=convtest gdktest genotest neurotest loadertest serialtest f0def.xml model.def
 
 all: $(TARGETS)
@@ -28,5 +28,6 @@
 GDKOBJS=list.o advlist.o param.o sstring.o 3d.o model.o modelparts.o errmanager.o \
 	neurolibrary.o geno.o genoconv.o extvalue.o framsg.o callbacks.o syntparam.o \
-	multirange.o multimap.o paramtabobj.o defgenoconv.o sstringutils.o paramobj.o rndutil.o \
+	multirange.o multimap.o paramtabobj.o defgenoconv.o sstringutils.o paramobj.o \
+	rndutil.o collectionobj.o hashtable.o stderrors.o 3dobject.o \
 	$(CONVMODULES)
 
@@ -58,4 +59,9 @@
 loadertest: libgdk.a $(LOADERTESTOBJS)
 	g++ $(LOADERTESTOBJS) -L. -lgdk -o $@
+
+SERIALTESTOBJS=serialtest.o virtfile.o stdiofile-autoinit.o stdiofile.o nonstd_stdio.o
+
+serialtest: libgdk.a $(SERIALTESTOBJS)
+	g++ $(SERIALTESTOBJS) -L. -lgdk -o $@
 
 neurocls-library.h: f0.def neurocls-library.m4
@@ -103,102 +109,138 @@
 # DO NOT DELETE
 
-3d.o: nonstd.h 3d.h framsg.h
+3d.o: nonstd_math.h framsg.h 3d.h
+3dobject.o: 3d.h 3dobject.h extvalue.h sstring.h param.h list.h nonstd.h
+3dobject.o: statrick.h virtfile.h framsg.h nonstd_stl.h threads.h
+3dobject.o: collectionobj.h hashtable.h
 advlist.o: advlist.h list.h nonstd.h callbacks.h statrick.h
 callbacks.o: callbacks.h list.h nonstd.h statrick.h
+collectionobj.o: collectionobj.h param.h sstring.h list.h nonstd.h statrick.h
+collectionobj.o: virtfile.h framsg.h extvalue.h nonstd_stl.h threads.h
+collectionobj.o: hashtable.h 3d.h nonstd_math.h stderrors.h sstringutils.h
 conv_f1.o: conv_f1.h genoconv.h geno.h sstring.h extvalue.h param.h list.h
-conv_f1.o: nonstd.h statrick.h virtfile.h model.h modelparts.h 3d.h
-conv_f1.o: sstringutils.h syntparam.h usertags.h paramtabobj.h advlist.h
-conv_f1.o: callbacks.h framsg.h multirange.h multimap.h
+conv_f1.o: nonstd.h statrick.h virtfile.h framsg.h nonstd_stl.h threads.h
+conv_f1.o: model.h nonstd_math.h modelparts.h 3d.h sstringutils.h syntparam.h
+conv_f1.o: usertags.h paramtabobj.h advlist.h callbacks.h multirange.h
+conv_f1.o: multimap.h
 convtest.o: genoconv.h geno.h sstring.h extvalue.h param.h list.h nonstd.h
-convtest.o: statrick.h virtfile.h model.h modelparts.h 3d.h sstringutils.h
-convtest.o: syntparam.h usertags.h paramtabobj.h advlist.h callbacks.h
-convtest.o: multimap.h multirange.h conv_f1.h printconvmap.h stdouterr.h
-convtest.o: errmanager.h framsg.h
+convtest.o: statrick.h virtfile.h framsg.h nonstd_stl.h threads.h model.h
+convtest.o: nonstd_math.h modelparts.h 3d.h sstringutils.h syntparam.h
+convtest.o: usertags.h paramtabobj.h advlist.h callbacks.h multimap.h
+convtest.o: multirange.h conv_f1.h printconvmap.h stdouterr.h errmanager.h
 defgenoconv.o: defgenoconv.h genoconv.h geno.h sstring.h extvalue.h param.h
-defgenoconv.o: list.h nonstd.h statrick.h virtfile.h gen-config.h conv_f1.h
-defgenoconv.o: model.h modelparts.h 3d.h sstringutils.h syntparam.h
-defgenoconv.o: usertags.h paramtabobj.h advlist.h callbacks.h
-errmanager.o: errmanager.h list.h nonstd.h sstring.h framsg.h
+defgenoconv.o: list.h nonstd.h statrick.h virtfile.h framsg.h nonstd_stl.h
+defgenoconv.o: threads.h
+errmanager.o: errmanager.h list.h nonstd.h sstring.h framsg.h threads.h
 extvalue.o: extvalue.h sstring.h param.h list.h nonstd.h statrick.h
-extvalue.o: virtfile.h framsg.h
-framsg.o: nonstd.h framsg.h
-gdktest.o: model.h modelparts.h 3d.h genoconv.h geno.h sstring.h extvalue.h
-gdktest.o: param.h list.h nonstd.h statrick.h virtfile.h sstringutils.h
-gdktest.o: syntparam.h usertags.h paramtabobj.h advlist.h callbacks.h
-gdktest.o: defgenoconv.h stdouterr.h errmanager.h framsg.h
+extvalue.o: virtfile.h framsg.h nonstd_stl.h threads.h sstringutils.h
+extvalue.o: collectionobj.h hashtable.h 3d.h 3dobject.h
+framsg.o: framsg.h nonstd_stdio.h
+fullprops.o: stdiofile.h virtfile.h sstring.h nonstd_dir.h model.h
+fullprops.o: nonstd_math.h modelparts.h 3d.h genoconv.h geno.h extvalue.h
+fullprops.o: param.h list.h nonstd.h statrick.h framsg.h nonstd_stl.h
+fullprops.o: threads.h sstringutils.h syntparam.h usertags.h paramtabobj.h
+fullprops.o: advlist.h callbacks.h defgenoconv.h stdouterr.h errmanager.h
+gdktest.o: stdiofile.h virtfile.h sstring.h nonstd_dir.h model.h
+gdktest.o: nonstd_math.h modelparts.h 3d.h genoconv.h geno.h extvalue.h
+gdktest.o: param.h list.h nonstd.h statrick.h framsg.h nonstd_stl.h threads.h
+gdktest.o: sstringutils.h syntparam.h usertags.h paramtabobj.h advlist.h
+gdktest.o: callbacks.h defgenoconv.h stdouterr.h errmanager.h
 genoconv.o: nonstd.h genoconv.h geno.h sstring.h extvalue.h param.h list.h
-genoconv.o: statrick.h virtfile.h multimap.h multirange.h
+genoconv.o: statrick.h virtfile.h framsg.h nonstd_stl.h threads.h multimap.h
+genoconv.o: multirange.h
 geno.o: geno.h sstring.h extvalue.h param.h list.h nonstd.h statrick.h
-geno.o: virtfile.h genoconv.h model.h modelparts.h 3d.h sstringutils.h
-geno.o: syntparam.h usertags.h paramtabobj.h advlist.h callbacks.h
+geno.o: virtfile.h framsg.h nonstd_stl.h threads.h genoconv.h model.h
+geno.o: nonstd_math.h modelparts.h 3d.h sstringutils.h syntparam.h usertags.h
+geno.o: paramtabobj.h advlist.h callbacks.h
 genotest.o: geno.h sstring.h extvalue.h param.h list.h nonstd.h statrick.h
-genotest.o: virtfile.h genoconv.h stdiofile.h sstringutils.h defgenoconv.h
+genotest.o: virtfile.h framsg.h nonstd_stl.h threads.h genoconv.h stdiofile.h
+genotest.o: nonstd_dir.h sstringutils.h defgenoconv.h
 genotypeloader.o: genotypeloader.h sstring.h multiparamload.h param.h list.h
-genotypeloader.o: nonstd.h statrick.h virtfile.h
+genotypeloader.o: nonstd.h statrick.h virtfile.h framsg.h extvalue.h
+genotypeloader.o: nonstd_stl.h threads.h
+hashtable.o: hashtable.h sstring.h
 list.o: list.h nonstd.h
 loadertest.o: genotypeloader.h sstring.h multiparamload.h param.h list.h
-loadertest.o: nonstd.h statrick.h virtfile.h
-model.o: nonstd.h model.h modelparts.h 3d.h genoconv.h geno.h sstring.h
-model.o: extvalue.h param.h list.h statrick.h virtfile.h sstringutils.h
-model.o: syntparam.h usertags.h paramtabobj.h advlist.h callbacks.h framsg.h
-model.o: multimap.h multirange.h errmanager.h
+loadertest.o: nonstd.h statrick.h virtfile.h framsg.h extvalue.h nonstd_stl.h
+loadertest.o: threads.h
+model.o: nonstd_math.h model.h modelparts.h 3d.h genoconv.h geno.h sstring.h
+model.o: extvalue.h param.h list.h nonstd.h statrick.h virtfile.h framsg.h
+model.o: nonstd_stl.h threads.h sstringutils.h syntparam.h usertags.h
+model.o: paramtabobj.h advlist.h callbacks.h multimap.h multirange.h
+model.o: errmanager.h
 modelparts.o: modelparts.h 3d.h genoconv.h geno.h sstring.h extvalue.h
-modelparts.o: param.h list.h nonstd.h statrick.h virtfile.h sstringutils.h
-modelparts.o: syntparam.h usertags.h paramtabobj.h model.h advlist.h
-modelparts.o: callbacks.h neurolibrary.h multirange.h defassign-f0_neuro.h
+modelparts.o: param.h list.h nonstd.h statrick.h virtfile.h framsg.h
+modelparts.o: nonstd_stl.h threads.h sstringutils.h syntparam.h usertags.h
+modelparts.o: paramtabobj.h model.h nonstd_math.h advlist.h callbacks.h
+modelparts.o: neurolibrary.h multirange.h defassign-f0_neuro.h
 modelparts.o: defassign-f0_part.h defassign-f0_joint.h f0classes.h
 modelparts.o: defassign-f0_neuroconn.h
 multimap.o: multimap.h multirange.h list.h nonstd.h
 multiparamload.o: multiparamload.h param.h sstring.h list.h nonstd.h
-multiparamload.o: statrick.h virtfile.h framsg.h
-multirange.o: multirange.h list.h nonstd.h
+multiparamload.o: statrick.h virtfile.h framsg.h extvalue.h nonstd_stl.h
+multiparamload.o: threads.h
+multirange.o: multirange.h list.h nonstd.h nonstd_stl.h
 neurofactory.o: neurofactory.h modelparts.h 3d.h genoconv.h geno.h sstring.h
 neurofactory.o: extvalue.h param.h list.h nonstd.h statrick.h virtfile.h
-neurofactory.o: sstringutils.h syntparam.h usertags.h paramtabobj.h
-neurofactory.o: neuroimpl.h model.h advlist.h callbacks.h framsg.h
-neurofactory.o: neuroimplfiles.h neuroimpl-simple.h neuroimpl-channels.h
-neurofactory.o: neuroimpl-fuzzy.h neuroimpl-body-gdk.h neurocls-factory.h
-neuroimpl-channels.o: neuroimpl-channels.h neuroimpl.h model.h modelparts.h
-neuroimpl-channels.o: 3d.h genoconv.h geno.h sstring.h extvalue.h param.h
-neuroimpl-channels.o: list.h nonstd.h statrick.h virtfile.h sstringutils.h
-neuroimpl-channels.o: syntparam.h usertags.h paramtabobj.h advlist.h
-neuroimpl-channels.o: callbacks.h framsg.h
-neuroimpl.o: neuroimpl.h model.h modelparts.h 3d.h genoconv.h geno.h
-neuroimpl.o: sstring.h extvalue.h param.h list.h nonstd.h statrick.h
-neuroimpl.o: virtfile.h sstringutils.h syntparam.h usertags.h paramtabobj.h
-neuroimpl.o: advlist.h callbacks.h framsg.h neurofactory.h
-neuroimpl-fuzzy.o: neuroimpl-fuzzy.h neuroimpl.h model.h modelparts.h 3d.h
-neuroimpl-fuzzy.o: genoconv.h geno.h sstring.h extvalue.h param.h list.h
-neuroimpl-fuzzy.o: nonstd.h statrick.h virtfile.h sstringutils.h syntparam.h
-neuroimpl-fuzzy.o: usertags.h paramtabobj.h advlist.h callbacks.h framsg.h
+neurofactory.o: framsg.h nonstd_stl.h threads.h sstringutils.h syntparam.h
+neurofactory.o: usertags.h paramtabobj.h neuroimpl.h model.h nonstd_math.h
+neurofactory.o: advlist.h callbacks.h neurolibrary.h
+neuroimpl-channels.o: neuroimpl-channels.h neuroimpl.h model.h nonstd_math.h
+neuroimpl-channels.o: modelparts.h 3d.h genoconv.h geno.h sstring.h
+neuroimpl-channels.o: extvalue.h param.h list.h nonstd.h statrick.h
+neuroimpl-channels.o: virtfile.h framsg.h nonstd_stl.h threads.h
+neuroimpl-channels.o: sstringutils.h syntparam.h usertags.h paramtabobj.h
+neuroimpl-channels.o: advlist.h callbacks.h
+neuroimpl.o: neuroimpl.h model.h nonstd_math.h modelparts.h 3d.h genoconv.h
+neuroimpl.o: geno.h sstring.h extvalue.h param.h list.h nonstd.h statrick.h
+neuroimpl.o: virtfile.h framsg.h nonstd_stl.h threads.h sstringutils.h
+neuroimpl.o: syntparam.h usertags.h paramtabobj.h advlist.h callbacks.h
+neuroimpl.o: neurofactory.h rndutil.h
+neuroimpl-fuzzy.o: neuroimpl-fuzzy.h neuroimpl.h model.h nonstd_math.h
+neuroimpl-fuzzy.o: modelparts.h 3d.h genoconv.h geno.h sstring.h extvalue.h
+neuroimpl-fuzzy.o: param.h list.h nonstd.h statrick.h virtfile.h framsg.h
+neuroimpl-fuzzy.o: nonstd_stl.h threads.h sstringutils.h syntparam.h
+neuroimpl-fuzzy.o: usertags.h paramtabobj.h advlist.h callbacks.h
 neuroimpl-fuzzy.o: neuroimpl-fuzzy-f0.h
-neuroimpl-fuzzy-f0.o: neuroimpl-fuzzy-f0.h sstring.h nonstd.h
-neuroimpl-simple.o: neuroimpl-simple.h neuroimpl.h model.h modelparts.h 3d.h
-neuroimpl-simple.o: genoconv.h geno.h sstring.h extvalue.h param.h list.h
-neuroimpl-simple.o: nonstd.h statrick.h virtfile.h sstringutils.h syntparam.h
-neuroimpl-simple.o: usertags.h paramtabobj.h advlist.h callbacks.h framsg.h
+neuroimpl-fuzzy-f0.o: neuroimpl-fuzzy-f0.h sstring.h nonstd_stl.h
+neuroimpl-simple.o: neuroimpl-simple.h neuroimpl.h model.h nonstd_math.h
+neuroimpl-simple.o: modelparts.h 3d.h genoconv.h geno.h sstring.h extvalue.h
+neuroimpl-simple.o: param.h list.h nonstd.h statrick.h virtfile.h framsg.h
+neuroimpl-simple.o: nonstd_stl.h threads.h sstringutils.h syntparam.h
+neuroimpl-simple.o: usertags.h paramtabobj.h advlist.h callbacks.h
 neurolibrary.o: neurolibrary.h advlist.h list.h nonstd.h callbacks.h
-neurolibrary.o: statrick.h param.h sstring.h virtfile.h modelparts.h 3d.h
-neurolibrary.o: genoconv.h geno.h extvalue.h sstringutils.h syntparam.h
-neurolibrary.o: usertags.h paramtabobj.h neurocls-library.h
+neurolibrary.o: statrick.h param.h sstring.h virtfile.h framsg.h modelparts.h
+neurolibrary.o: 3d.h genoconv.h geno.h extvalue.h nonstd_stl.h threads.h
+neurolibrary.o: sstringutils.h syntparam.h usertags.h paramtabobj.h
 neurotest.o: geno.h sstring.h extvalue.h param.h list.h nonstd.h statrick.h
-neurotest.o: virtfile.h genoconv.h stdiofile.h sstringutils.h defgenoconv.h
-neurotest.o: neuroimpl.h model.h modelparts.h 3d.h syntparam.h usertags.h
-neurotest.o: paramtabobj.h advlist.h callbacks.h framsg.h neurofactory.h
+neurotest.o: virtfile.h framsg.h nonstd_stl.h threads.h genoconv.h
+neurotest.o: stdiofile.h nonstd_dir.h sstringutils.h defgenoconv.h
+neurotest.o: neuroimpl.h model.h nonstd_math.h modelparts.h 3d.h syntparam.h
+neurotest.o: usertags.h paramtabobj.h advlist.h callbacks.h neurofactory.h
 neurotest.o: stdouterr.h errmanager.h
-param.o: param.h sstring.h list.h nonstd.h statrick.h virtfile.h extvalue.h
-param.o: framsg.h sstringutils.h
+nonstd_stdio.o: nonstd_stdio.h
+param.o: param.h sstring.h list.h nonstd.h statrick.h virtfile.h framsg.h
+param.o: extvalue.h nonstd_stl.h threads.h sstringutils.h
 paramobj.o: paramobj.h param.h sstring.h list.h nonstd.h statrick.h
-paramobj.o: virtfile.h extvalue.h
+paramobj.o: virtfile.h framsg.h extvalue.h nonstd_stl.h threads.h
 paramtabobj.o: paramtabobj.h param.h sstring.h list.h nonstd.h statrick.h
-paramtabobj.o: virtfile.h
+paramtabobj.o: virtfile.h framsg.h
 printconvmap.o: printconvmap.h sstring.h multimap.h multirange.h list.h
 printconvmap.o: nonstd.h
-sstring.o: sstring.h nonstd.h
+rndutil.o: rndutil.h nonstd.h nonstd_math.h
+serialtest.o: collectionobj.h param.h sstring.h list.h nonstd.h statrick.h
+serialtest.o: virtfile.h framsg.h extvalue.h nonstd_stl.h threads.h
+serialtest.o: hashtable.h 3d.h
+sstring.o: sstring.h nonstd_stl.h extvalue.h param.h list.h nonstd.h
+sstring.o: statrick.h virtfile.h framsg.h threads.h
 sstringutils.o: sstringutils.h sstring.h virtfile.h framsg.h
-stdiofile-autoinit.o: stdiofile.h virtfile.h sstring.h
-stdiofile.o: stdiofile.h virtfile.h sstring.h nonstd.h nonstd_io.h
+stderrors.o: stderrors.h list.h nonstd.h sstring.h sstringutils.h virtfile.h
+stderrors.o: framsg.h
+stdiofile-autoinit.o: stdiofile.h virtfile.h sstring.h nonstd_dir.h
+stdiofile.o: stdiofile.h virtfile.h sstring.h nonstd_dir.h nonstd_stdio.h
+stdiofile.o: framsg.h
 stdouterr.o: stdouterr.h errmanager.h list.h nonstd.h sstring.h framsg.h
+stdouterr.o: threads.h virtfile.h
 syntparam.o: nonstd.h syntparam.h param.h sstring.h list.h statrick.h
-syntparam.o: virtfile.h paramobj.h
+syntparam.o: virtfile.h framsg.h paramobj.h
 virtfile.o: virtfile.h
Index: /cpp/gdk/callbacks.h
===================================================================
--- /cpp/gdk/callbacks.h	(revision 103)
+++ /cpp/gdk/callbacks.h	(revision 104)
@@ -39,5 +39,5 @@
 void (*fun)(void*,long);
   public:
-FunctionCallbackNode(void (*f)(void*,long),void *d):fun(f),userdata(d) {}
+FunctionCallbackNode(void (*f)(void*,long),void *d):userdata(d),fun(f) {}
 void action(long calldata) {(*fun)(userdata,calldata);}
 int equals(CallbackNode*);
@@ -51,5 +51,5 @@
 void (*fun)(void*,void*,long);
   public:
-StatrickCallbackNode(void *o,void (*f)(void*,void*,long),void *d):object(o),fun(f),userdata(d) {}
+StatrickCallbackNode(void *o,void (*f)(void*,void*,long),void *d):object(o),userdata(d),fun(f) {}
 void action(long calldata) {(*fun)(object,userdata,calldata);}
 int equals(CallbackNode*);
Index: /cpp/gdk/collectionobj.cpp
===================================================================
--- /cpp/gdk/collectionobj.cpp	(revision 104)
+++ /cpp/gdk/collectionobj.cpp	(revision 104)
@@ -0,0 +1,354 @@
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
+#include "collectionobj.h"
+#include "nonstd_math.h" //sqrt in borland
+#include "stderrors.h"
+#include "nonstd_stl.h"
+#include "sstringutils.h"
+
+#define FIELDSTRUCT VectorObject
+ParamEntry vector_paramtab[]=
+{
+{"Vector",1,11,"Vector","Vector is 1-dimensional array, indexed by integer value (starting from 0). "
+ "Multidimensional arrays can be simulated by putting other Vector objects into the Vector.\n"
+ "Example:\nvar v=Vector.new();\nv.add(123); v.add(\"string\");",},
+{"clear",0,PARAM_NOSTATIC,"clear data","p()",PROCEDURE(p_clear),},
+{"size",0,PARAM_READONLY+PARAM_NOSTATIC,"element count","d",GETONLY(size),},
+{"remove",0,PARAM_NOSTATIC,"remove at position","p(d position)",PROCEDURE(p_remove),},
+{"get",0,PARAM_NOSTATIC,"get value at position","p x(d position)",PROCEDURE(p_get),},
+{"set",0,PARAM_NOSTATIC,"set value at position","p(d position,x value)",PROCEDURE(p_set),},
+{"add",0,PARAM_NOSTATIC,"append at the end","p(x value)",PROCEDURE(p_add),},
+{"find",0,PARAM_NOSTATIC,"find","p d(x value)",PROCEDURE(p_find),"returns the element index or -1 if not found"},
+{"avg",0,PARAM_READONLY+PARAM_NOSTATIC,"average","f",GETONLY(avg)},
+{"stdev",0,PARAM_READONLY+PARAM_NOSTATIC,"standard deviation","f",GETONLY(stdev),"=sqrt(sum((element[i]-avg)^2)/(size-1)) which is estimated population std.dev. from sample std.dev."},
+{"toString",0,PARAM_READONLY+PARAM_NOSTATIC,"textual form","s",GETONLY(toString),},
+{"new",0,0,"create new Vector","p oVector()",STATICPROCEDURE(p_new),},
+{0,0,0,},
+};
+#undef FIELDSTRUCT
+
+#define FIELDSTRUCT DictionaryObject
+ParamEntry dictionary_paramtab[]=
+{
+{"Dictionary",1,9,"Dictionary","Dictionary associates stored values with string keys "
+ "(\"key\" is the first argument in get/set/remove functions). Integer \"key\" can be "
+ "used to enumerate all elements (the sequence of elements is not preserved).\n"
+ "Example:\nvar d=Dictionary.new(); d.set(\"name\",\"John\"); d.set(\"age\",44);\n"
+ "var i;\nfor(i=0;i<d.size;i++) Simulator.print(d.getKey(i)+\" is \"+d.get(i));",},
+{"clear",0,PARAM_NOSTATIC,"clear data","p()",PROCEDURE(p_clear),},
+{"size",0,PARAM_NOSTATIC,"element count","d",GETONLY(size),},
+{"remove",0,PARAM_NOSTATIC,"remove named or indexed element","p(x key)",PROCEDURE(p_remove),},
+{"get",0,PARAM_NOSTATIC,"get named or indexed element","p x(x key)",PROCEDURE(p_get),},
+{"getKey",0,PARAM_NOSTATIC,"get a key of the indexed element","p s(d index)",PROCEDURE(p_getKey),},
+{"set",0,PARAM_NOSTATIC,"set named or indexed element","p(x key,x value)",PROCEDURE(p_set),},
+{"find",0,PARAM_NOSTATIC,"find","p s(x value)",PROCEDURE(p_find),"returns the element key or null if not found"},
+{"new",0,0,"create new Dictionary","p oDictionary()",STATICPROCEDURE(p_new),},
+{"toString",0,PARAM_READONLY+PARAM_NOSTATIC,"textual form","s",GETONLY(toString),},
+{0,0,0,},
+};
+#undef FIELDSTRUCT
+
+Param VectorObject::par(vector_paramtab);
+Param DictionaryObject::par(dictionary_paramtab);
+
+/////////////////////////////////////////
+
+VectorObject::VectorObject(Pt3D &pt)
+	:readonly(0),owndata(1)
+{
+set(0,ExtValue(pt.x));
+set(1,ExtValue(pt.y));
+set(2,ExtValue(pt.z));
+}
+
+void VectorObject::clear()
+{
+if (owndata)
+for(int i=data.size()-1;i>=0;i--)
+	{
+	ExtValue *v=(ExtValue*)data.get(i);
+	if (v) delete v;
+	}
+//nie tak spektakularny jak rasowe bugi roku ale tez idiotyczny :>
+//wszystko przez to ze poczatkowo bylo tylko uzywane w destruktorze...
+data.clear();
+}
+
+void VectorObject::p_remove(PARAMPROCARGS)
+{
+if (readonly) return;
+int i=args->getInt();
+if ((i<0)||(i>=data.size())) return;
+ExtValue *v=(ExtValue*)data.get(i);
+if (v) delete v;
+data-=i;
+}
+
+void VectorObject::set(int i,const ExtValue& val)
+{
+int oldsize=data.size();
+if (i<0) return;
+ExtValue *v=(ExtValue*)data.get(i);
+if (v) delete v;
+data.set(i,new ExtValue(val));
+i--;
+while(i>=oldsize)
+	{
+	data.set(i,0);
+	i--;
+	}
+}
+
+void VectorObject::p_get(PARAMPROCARGS)
+{
+int i=args->getInt();
+if (listIndexCheck(&data,i,"VectorObject","get"))
+	{
+	ExtValue *v=get(i);
+	if (v)
+		{
+		*ret=*v;
+		return;
+		}
+	}
+*ret=ExtValue();
+}
+
+void VectorObject::get_avg(ExtValue* ret)
+{
+if (!data.size()) {ret->setEmpty(); return;}
+double s=0.0;
+for(int i=data.size()-1;i>=0;i--)
+	s+=((ExtValue*)data.get(i))->getDouble();
+s/=data.size();
+ret->setDouble(s);
+}
+
+SString VectorObject::serialize() const
+{
+SString out="[";
+	{
+	for(int i=0;i<data.size();i++)
+		{
+		ExtValue* v=(ExtValue*)data.get(i);
+		if (i) out+=",";
+		if (v)
+			out+=v->serialize();
+		else
+			out+="null";
+		}
+	}
+out+="]";
+//sprintf(out.directAppend(20),"<Vector@%p>",this);out.endAppend();
+return out;
+}
+
+static ThreadSingleton<SList> tostring_trace;
+
+void VectorObject::get_toString(ExtValue* ret)
+{
+SString out="[";
+//static SListTempl<VectorObject*> trace;
+if (tostring_trace.getref().find(this)>=0)
+	out+="...";
+else
+	{
+	tostring_trace.getref()+=this;
+	for(int i=0;i<data.size();i++)
+		{
+		ExtValue* v=(ExtValue*)data.get(i);
+		if (i) out+=",";
+		if (v)
+			out+=v->getString();
+		else
+			out+="null";
+		}
+	tostring_trace.getref()-=this;
+	}
+out+="]";
+ret->setString(out);
+}
+
+void VectorObject::get_stdev(ExtValue* ret)
+{
+if (!data.size()) {ret->setEmpty(); return;}
+get_avg(ret);
+double a=ret->getDouble();
+double s=0.0;
+for(int i=data.size()-1;i>=0;i--)
+	{
+	double d=a-((ExtValue*)data.get(i))->getDouble();
+	s+=d*d;
+	}
+ret->setDouble(sqrt(s/max(1,data.size()-1)));
+}
+
+void VectorObject::p_find(PARAMPROCARGS)
+{
+short i;
+for(i=0;i<data.size();i++)
+	{
+	if ((*args)==(*get(i)))
+		{ret->setInt(i);return;}
+	}
+ret->setInt(-1);
+}
+
+VectorObject* VectorObject::fromObject(const ExtObject& o)
+{
+return (VectorObject*)o.getTarget(par.getName());
+}
+
+/////////////////////////////
+
+void DictionaryObject::clear()
+{
+for(HashEntryIterator it(hash);it.isValid();)
+	{
+        ExtValue *v=(ExtValue*)hash.remove(it);
+	if (v) delete v;
+	}
+hash.clear();
+hash.init();
+}
+
+void DictionaryObject::p_find(PARAMPROCARGS)
+{
+for(HashEntryIterator it(hash);it.isValid();it++)
+	{
+	if ((*args)==(*((ExtValue*)it->value)))
+		{
+		ret->setString(it->key);
+		return;
+		}
+	}
+ret->setEmpty();
+}
+
+HashEntryIterator* DictionaryObject::getIndexIterator(int i)
+{
+if (i<0) return 0;
+if (i>=hash.getSize()) return 0;
+
+if ((!it.isValid())||(it_index>i))
+	{
+	it=HashEntryIterator(hash);
+	it_index=0;
+	}
+while(it.isValid())
+	{
+	if (it_index==i)
+		return &it;
+	it_index++;
+	it++;
+	}
+return 0;
+}
+
+void DictionaryObject::p_remove(PARAMPROCARGS)
+{
+if ((args->type==TInt)||(args->type==TDouble))
+	{
+	HashEntryIterator* iter=getIndexIterator(args->getInt());
+	if (iter)
+		{
+		ExtValue *oldval=(ExtValue*)hash.remove(*iter);
+		if (oldval) {*ret=*oldval; delete oldval;} else *ret=ExtValue();
+		}
+	}
+else
+	{
+	ExtValue *oldval=(ExtValue*)hash.remove(args[0].getString());
+	if (oldval) {*ret=*oldval; delete oldval;} else *ret=ExtValue();
+	}
+}
+
+void DictionaryObject::p_get(PARAMPROCARGS)
+{
+if ((args->type==TInt)||(args->type==TDouble))
+	{
+	HashEntryIterator* iter=getIndexIterator(args->getInt());
+	if (iter && (*iter)->value)
+		{
+		*ret=*((ExtValue*)(*iter)->value);
+		return;
+		}
+	}
+else
+	{
+	ExtValue *val=(ExtValue*)hash.get(args[0].getString());
+	if (val)
+		{
+		*ret=*val;
+		return;
+		}
+	}
+*ret=ExtValue();
+}
+
+void DictionaryObject::p_getKey(PARAMPROCARGS)
+{
+HashEntryIterator* iter=getIndexIterator(args->getInt());
+if (iter)
+	{
+	*ret=(*iter)->key;
+	return;
+	}
+*ret=ExtValue();
+}
+
+void DictionaryObject::p_set(PARAMPROCARGS)
+{
+ExtValue *newval=(args[0].getType()==TUnknown)?0:new ExtValue(args[0]);
+ExtValue *oldval=(ExtValue*)hash.put(args[1].getString(),newval);
+if (oldval) {*ret=*oldval; delete oldval;} else *ret=ExtValue();
+}
+
+SString DictionaryObject::serialize() const
+{
+SString out="{";
+	{
+	for(HashEntryIterator it(hash);it.isValid();)
+		{
+		out+="\"";
+		SString q=it->key; sstringQuote(q);
+		out+=q;
+		out+="\":";
+		out+=((ExtValue*)it->value)->serialize();
+		it++;
+		if (it.isValid()) out+=",";
+		}
+	}
+out+="}";
+return out;
+}
+
+void DictionaryObject::get_toString(ExtValue* ret)
+{
+SString out="{";
+//static SListTempl<DictionaryObject*> trace;
+if (tostring_trace.getref().find(this)>=0)
+	out+="...";
+else
+	{
+	tostring_trace.getref()+=this;
+	for(HashEntryIterator it(hash);it.isValid();)
+		{
+		out+=it->key;
+		out+=":";
+		out+=((ExtValue*)it->value)->getString();
+		it++;
+		if (it.isValid()) out+=",";
+		}
+	tostring_trace.getref()-=this;
+	}
+out+="}";
+ret->setString(out);
+}
+
+DictionaryObject* DictionaryObject::fromObject(const ExtObject& o)
+{
+return (DictionaryObject*)o.getTarget(par.getName());
+}
Index: /cpp/gdk/collectionobj.h
===================================================================
--- /cpp/gdk/collectionobj.h	(revision 104)
+++ /cpp/gdk/collectionobj.h	(revision 104)
@@ -0,0 +1,78 @@
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
+#ifndef _COLLECTIONOBJ_H_
+#define _COLLECTIONOBJ_H_
+
+#include "param.h"
+#include "extvalue.h"
+#include "hashtable.h"
+#include "3d.h"
+
+/** object collection, indexed by int */
+class VectorObject: public DestrBase
+{
+  public:
+SList data;
+int readonly:1, owndata:1;
+void clear();
+ExtValue *get(int i) {return (ExtValue*)data.get(i);}
+void set(int i,const ExtValue& val);
+
+static Param par;
+VectorObject(Pt3D& pt);
+VectorObject():readonly(0),owndata(1) {}
+~VectorObject() {clear();}
+#define STATRICKCLASS VectorObject
+PARAMPROCDEF(p_clear) {if (readonly) return; clear();}
+PARAMGETDEF(size) {arg1->setInt(data.size());}
+PARAMGETDEF(avg);
+PARAMGETDEF(stdev);
+PARAMPROCDEF(p_remove);
+PARAMPROCDEF(p_get);
+PARAMPROCDEF(p_find);
+PARAMPROCDEF(p_set) {if (!readonly) set(arg1[1].getInt(),arg1[0]);}
+PARAMPROCDEF(p_add) {if (readonly) return; /*ExtValue tmp; get_toString(&tmp); printf("%s += %s",(const char*)tmp.getString(),(const char*)arg1[0].getString());*/ data+=new ExtValue(arg1[0]); /*get_toString(&tmp); printf(" -> %s\n",(const char*)tmp.getString());*/ arg2->setInt(data.size()-1);}
+PARAMGETDEF(toString);
+#undef STATRICKCLASS
+static void p_new(void*,ExtValue*args,ExtValue*ret)
+	{ret->setObject(ExtObject(&par,new VectorObject));}
+SString serialize() const;
+ExtObject makeObject() {return ExtObject(&par,this);}
+
+static VectorObject* fromObject(const ExtObject& o);
+};
+
+/** object collection, indexed by name */
+class DictionaryObject: public DestrBase
+{
+  public:
+HashTable hash;
+HashEntryIterator it;
+int it_index;
+
+void clear();
+HashEntryIterator* getIndexIterator(int i);
+
+static Param par;
+DictionaryObject():it(hash),it_index(-1) {}
+~DictionaryObject() {clear();}
+#define STATRICKCLASS DictionaryObject
+PARAMPROCDEF(p_clear) {clear();}
+PARAMGETDEF(size) {arg1->setInt(hash.getSize());}
+PARAMPROCDEF(p_remove);
+PARAMPROCDEF(p_get);
+PARAMPROCDEF(p_getKey);
+PARAMPROCDEF(p_set);
+PARAMPROCDEF(p_find);
+PARAMGETDEF(toString);
+#undef STATRICKCLASS
+SString serialize() const;
+static void p_new(void*,ExtValue*args,ExtValue*ret)
+	{ret->setObject(ExtObject(&par,new DictionaryObject));} //NOWY KANDYDAT NA BUGA ROKU!!!
+static DictionaryObject* fromObject(const ExtObject& v);
+ExtObject makeObject() {return ExtObject(&par,this);}
+};
+
+#endif
Index: /cpp/gdk/conv_f1.cpp
===================================================================
--- /cpp/gdk/conv_f1.cpp	(revision 103)
+++ /cpp/gdk/conv_f1.cpp	(revision 104)
@@ -261,5 +261,9 @@
 lastNeuroClassParam();
 if (neuro_cls_param)
-	neuro_cls_param->setById(name,ExtValue(value));
+	{
+	ExtValue e(value);
+	const ExtValue &re(e);
+	neuro_cls_param->setById(name,re);
+	}
 }
 
Index: /cpp/gdk/errmanager.cpp
===================================================================
--- /cpp/gdk/errmanager.cpp	(revision 103)
+++ /cpp/gdk/errmanager.cpp	(revision 104)
@@ -5,10 +5,11 @@
 #include "errmanager.h"
 
-ErrorManager globalErrorManager;
 
 void FramMessage(const char *o,const char *m,const char *bl,int w)
 {
-globalErrorManager.send(o,m,bl,w);
+ErrorManager::instance.getref().send(o,m,bl,w);
 }
+
+ThreadSingleton<ErrorManager> ErrorManager::instance;
 
 void ErrorManager::send(int level,const char *o,const char *m,const char *bl,int w)
@@ -76,5 +77,5 @@
 {
 if (isEnabled()) return;
-globalErrorManager.add(this);
+ErrorManager::instance.getref().add(this);
 }
 
@@ -82,5 +83,5 @@
 {
 if (!isEnabled()) return;
-globalErrorManager.remove(this);
+ErrorManager::instance.getref().remove(this);
 }
 
Index: /cpp/gdk/errmanager.h
===================================================================
--- /cpp/gdk/errmanager.h	(revision 103)
+++ /cpp/gdk/errmanager.h	(revision 104)
@@ -9,4 +9,5 @@
 #include "sstring.h"
 #include "framsg.h"
+#include "threads.h"
 
 class ErrorHandlerBase;
@@ -26,7 +27,7 @@
 	{send(handlers.size()-1,o,m,bl,w);}
 ~ErrorManager() {removeAll();}
+
+static ThreadSingleton<ErrorManager> instance;
 };
-
-extern ErrorManager globalErrorManager;
 
 ////////////////////////////////////////
@@ -51,5 +52,5 @@
 void disable();
 
-ErrorHandlerBase(int opts=0):options(opts),mgr(0)
+ErrorHandlerBase(int opts=0):mgr(0),options(opts)
 	{if (!(options&DontEnable)) enable();}
 ~ErrorHandlerBase()
@@ -87,4 +88,17 @@
 };
 
+class ErrorRedirector: public ErrorHandlerBase
+{
+	ErrorManager *other_mgr;
+public:
+	ErrorRedirector(ErrorManager *om)
+		:ErrorHandlerBase(),other_mgr(om) {}
+
+	void handle(const char *o,const char *m,const char *bl,int w)
+		{
+		other_mgr->send(o,m,bl,w);
+		}
+};
+
 #endif
 
